"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const plugins_1 = require("@sewing-kit/plugins");
const PLUGIN = 'SewingKit.Babel';
exports.babelConfigurationHooks = plugins_1.createProjectPlugin(PLUGIN, ({ project, tasks: { build, test, dev } }) => {
    const addHooks = (hooks) => (Object.assign(Object.assign({}, hooks), { babelConfig: new plugins_1.WaterfallHook(), babelIgnorePatterns: new plugins_1.WaterfallHook(), babelExtensions: project instanceof plugins_1.Package
            ? new plugins_1.WaterfallHook()
            : undefined }));
    build.hook(({ hooks }) => {
        hooks.configureHooks.hook(addHooks);
    });
    dev.hook(({ hooks }) => {
        hooks.configureHooks.hook(addHooks);
    });
    test.hook(({ hooks }) => {
        hooks.configureHooks.hook(addHooks);
    });
});
function addBabelPlugin(plugin) {
    const id = `${PLUGIN}.AddBabelPlugin`;
    return createProjectPluginTargettingAllConfigurationHooks(id, (hooks) => {
        var _a;
        (_a = hooks.babelConfig) === null || _a === void 0 ? void 0 : _a.hook((config) => {
            var _a;
            return (Object.assign(Object.assign({}, config), { plugins: [...(_a = config.plugins, (_a !== null && _a !== void 0 ? _a : [])), plugin] }));
        });
    });
}
exports.addBabelPlugin = addBabelPlugin;
function addBabelPreset(preset) {
    const id = `${PLUGIN}.AddBabelPreset`;
    return createProjectPluginTargettingAllConfigurationHooks(id, (hooks) => {
        var _a;
        (_a = hooks.babelConfig) === null || _a === void 0 ? void 0 : _a.hook((config) => {
            var _a;
            return (Object.assign(Object.assign({}, config), { presets: [...(_a = config.presets, (_a !== null && _a !== void 0 ? _a : [])), preset] }));
        });
    });
}
exports.addBabelPreset = addBabelPreset;
function createProjectPluginTargettingAllConfigurationHooks(id, configurator) {
    return plugins_1.createProjectPlugin(id, ({ tasks: { build, dev, test } }) => {
        build.hook(({ hooks }) => {
            hooks.configure.hook(configurator);
        });
        dev.hook(({ hooks }) => {
            hooks.configure.hook(configurator);
        });
        test.hook(({ hooks }) => {
            hooks.configure.hook(configurator);
        });
    });
}
